

/// Originall Written by @aligator for NT7 and published free on Futures.IO (Later it was pirated by a 3rd party vendor and sold as part of a package)
/// Version 1.0, October 7, 2011
/// Credit is given to Raghee Horner (IBFX) for intoducing this setup.
/// Refer to Raghee's webinars to better understand how this setup is used.

/// NOTES:
/// Version 2.0, September6, 2018
/* 
    This is an adaptation of the GRAB (GRB) setup used by Raghee Horner of InterbankFX for trading currency pairs. 
 
    I wrote this indicator based on a chart setup used by Raghee Horner for trading currency pairs but it can be
    applied to any instrument. So, credit for the idea goes to Ms. Horner.
 
    Although this indicator is very simple, it is very powerful when used correctly. The indicator is a trend 
    following setup that will keep one out of choppy markets and on the right side of the trend.
 
    It is helpful to watch one of Raghee's seminars on IBFX (if still available) to understand how this indicator is applied.
 */

/// Enjoy!!

/// Added on October 10, 2011: 

/// Here is a link to free Raghee Horner's eBook on this setup.

/// http://www.dailyforextradingedge.com/sites/default/files/ebook.pdf
 
/// Added on November 2, 2011
/*
    When I see Raghee in a couple of weeks in Traders' Expo in Las Vegas I will discuss specifics of this setup and report back.
    Also, will tell her that "Tiberius" said" You didn't tell me that Raghee was so good looking. Because she is."
*/
/// Added on November 6, 2011
/// Revised to add shading to show EMA as a band. 
/// 
/// Exported using NT8.0.15 64-bit

#region Using declarations
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Diagnostics.CodeAnalysis;
using System.Windows;
using System.Reflection;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.Tools;
using NinjaTrader.NinjaScript.DrawingTools;
using NinjaTrader.NinjaScript.Indicators;
#endregion

namespace NinjaTrader.NinjaScript.Indicators.mah_Indicators
{
    /// <summary>

    /// </summary>
    public class mahTrendGRaBer : Indicator
    {
        #region Variables
       		private bool 		colorbars 		= false;
			private bool 		colorzone 		= false;
       		private bool 		colorOutline 	= false;		
			private int 		zopacity	= 3;
			private Brush 		zoneColor	= Brushes.Gray;
			private Brush 		maUpColor	= Brushes.Lime;
			private Brush 		maDownColor	= Brushes.Red;
		
            private int emah = 34; // Default setting for Emah
            private int emac = 34; // Default setting for Emac
            private int emal = 34; // Default setting for Emal
		
			private Brush barColorCondition1		= Brushes.Chartreuse;
			private Brush barColorCondition2		= Brushes.Green;
			private Brush barColorCondition3		= Brushes.LightBlue;
			private Brush barColorCondition4		= Brushes.RoyalBlue;
			private Brush barColorCondition5		= Brushes.DarkOrange;
			private Brush barColorCondition6		= Brushes.Red;
		
			private Brush candleOutlineCondition1	= Brushes.Chartreuse;
			private Brush candleOutlineCondition2	= Brushes.Green;
			private Brush candleOutlineCondition3	= Brushes.LightBlue;
			private Brush candleOutlineCondition4	= Brushes.RoyalBlue;
			private Brush candleOutlineCondition5	= Brushes.DarkOrange;
			private Brush candleOutlineCondition6	= Brushes.Red;
        #endregion

        protected override void OnStateChange()
        {
            if (State == State.SetDefaults)
            {
                Name = "mahTrendGRaBer";
                Description = "This is an adaptation of the GRAB (GRB) setup used by Raghee Horner of InterbankFX for trading currency pairs.";
				AddPlot(new Stroke(Brushes.ForestGreen), PlotStyle.Line, "EmaHigh");
				AddPlot(new Stroke(Brushes.MediumBlue), PlotStyle.Line, "EmaClose");
				AddPlot(new Stroke(Brushes.Red), PlotStyle.Line, "EmaLow");
				IsOverlay				= true;
            }
			
			else if (State == State.Configure)
			{
				Plots[0].Width = 1;
				Plots[1].Width = 2;
				Plots[2].Width = 1;
				Plots[0].DashStyleHelper = DashStyleHelper.Dot;
				Plots[1].DashStyleHelper = DashStyleHelper.Dot;
				Plots[2].DashStyleHelper = DashStyleHelper.Dot;				
			}
        }

        protected override void OnBarUpdate()
        {
			// Condition set 1
            if (Open[0] <= Close[0]
                && Close[0] > EMA(High, Emah)[0])
            {
				if (colorbars)
				{
				BarBrush = barColorCondition1;
				}
				if (colorOutline)
				{
                CandleOutlineBrush = candleOutlineCondition1;
				}
            }

            // Condition set 2
            if (Open[0] >= Close[0]
                && Close[0] > EMA(High, Emah)[0])
            {
				if (colorbars)
				{
				BarBrush = barColorCondition2;
				}
				if (colorOutline)
				{
                CandleOutlineBrush = candleOutlineCondition2;
				}
            }

            // Condition set 3
            if (Open[0] <= Close[0]
                && Close[0] < EMA(High, Emah)[0]
                && Close[0] > EMA(Low, Emal)[0])
            {
				if (colorbars)
				{
				BarBrush = barColorCondition3;
				}
				if (colorOutline)
				{
                CandleOutlineBrush = candleOutlineCondition3;
				}
            }

            // Condition set 4
            if (Open[0] >= Close[0]
                && Close[0] < EMA(High, Emah)[0]
                && Close[0] > EMA(Low, Emal)[0])
            {
				if (colorbars)
				{
				BarBrush = barColorCondition4;
				}
				if (colorOutline)
				{
                CandleOutlineBrush = candleOutlineCondition4;
				}
            }

            // Condition set 5
            if (Open[0] <= Close[0]
                && Close[0] < EMA(Low, Emal)[0])
            {
				if (colorbars)
				{
				BarBrush = barColorCondition5;
				}
				if (colorOutline)
				{
                CandleOutlineBrush = candleOutlineCondition5;
				}
            }

            // Condition set 6
            if (Open[0] >= Close[0]
                && Close[0] < EMA(Low, Emal)[0])
            {
				if (colorbars)
				{
				BarBrush = barColorCondition6;
				}
				if (colorOutline)
				{
                CandleOutlineBrush = candleOutlineCondition6;
				}
            }

            // Plot EMA for High, Low, and Close.
            {
				EmaHigh[0] = EMA(High, Emah)[0];
                EmaClose[0] = EMA(Close, Emac)[0];
                EmaLow[0] = EMA(Low, Emal)[0];
			}
			
			if(IsRising(EmaClose))
			PlotBrushes[1][0] = MaUpColor;
			else
			PlotBrushes[1][0] = MaDownColor;	
			
			if (Colorzone)
			{
				Draw.Region(this,"MABands",CurrentBar, 0, EmaHigh, EmaLow, Brushes.Transparent, ZoneColor, Zopacity);
			}
        }

        #region Properties
        [Browsable(false)]	
        [XmlIgnore()]		
        public Series<double> EmaHigh
        {
            get { return Values[0]; }
        }

        [Browsable(false)]	
        [XmlIgnore()]		
        public Series<double> EmaClose
        {
            get { return Values[1]; }
        }

        [Browsable(false)]	
        [XmlIgnore()]		
        public Series<double> EmaLow
        {
            get { return Values[2]; }
        }

        [Display(Description = "Default value for EMA of High", GroupName = "Parameters", Order = 1)]
        public int Emah
        {
            get { return emah; }
            set { emah = Math.Max(1, value); }
        }

        [Display(Description = "Default value for EMA of Close", GroupName = "Parameters", Order = 1)]
        public int Emac
        {
            get { return emac; }
            set { emac = Math.Max(1, value); }
        }

        [Display(Description = "Default value for EMA of Low", GroupName = "Parameters", Order = 1)]
        public int Emal
        {
            get { return emal; }
            set { emal = Math.Max(1, value); }
        }
		
		[XmlIgnore]	
		[Display(Name = "BarCondition1", Description = "Color of BarCondition1.", GroupName = "Visual", Order = 1)]
        public Brush BarCondition1
        {
            get { return barColorCondition1; }
            set { barColorCondition1 = value; }
        }

        [Browsable(false)]
        public string BarCondition1Serialize
        {
            get { return Serialize.BrushToString(barColorCondition1); }
            set { barColorCondition1 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]	
		[Display(Name = "BarCondition2", Description = "Color of BarCondition2.", GroupName = "Visual", Order = 2)]
        public Brush BarCondition2
        {
            get { return barColorCondition2; }
            set { barColorCondition2 = value; }
        }

        [Browsable(false)]
        public string BarCondition2Serialize
        {
            get { return Serialize.BrushToString(barColorCondition2); }
            set { barColorCondition2 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]	
		[Display(Name = "BarCondition3", Description = "Color of BarCondition3.", GroupName = "Visual", Order = 3)]
        public Brush BarCondition3
        {
            get { return barColorCondition3; }
            set { barColorCondition3 = value; }
        }

        [Browsable(false)]
        public string BarCondition3Serialize
        {
            get { return Serialize.BrushToString(barColorCondition3); }
            set { barColorCondition3 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]	
		[Display(Name = "BarCondition4", Description = "Color of BarCondition4.", GroupName = "Visual", Order = 4)]
        public Brush BarCondition4
        {
            get { return barColorCondition4; }
            set { barColorCondition4 = value; }
        }

        [Browsable(false)]
        public string BarCondition4Serialize
        {
            get { return Serialize.BrushToString(barColorCondition4); }
            set { barColorCondition4 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]		
		[Display(Name = "BarCondition5", Description = "Color of BarCondition5.", GroupName = "Visual", Order = 5)]
        public Brush BarCondition5
        {
            get { return barColorCondition5; }
            set { barColorCondition5 = value; }
        }

        [Browsable(false)]
        public string BarCondition5Serialize
        {
            get { return Serialize.BrushToString(barColorCondition5); }
            set { barColorCondition5 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]	
		[Display(Name = "BarCondition6", Description = "Color of BarCondition6.", GroupName = "Visual", Order = 6)]
        public Brush BarCondition6
        {
            get { return barColorCondition6; }
            set { barColorCondition6 = value; }
        }

        [Browsable(false)]
        public string BarCondition6Serialize
        {
            get { return Serialize.BrushToString(barColorCondition6); }
            set { barColorCondition6 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]	
		[Display(Name = "CandleOutlineCondition1", Description = "Color of CandleOutlineCondition1.", GroupName = "Visual", Order = 1)]
        public Brush CandleOutlineCondition1
        {
            get { return candleOutlineCondition1; }
            set { candleOutlineCondition1 = value; }
        }

        [Browsable(false)]
        public string CandleOutlineCondition1Serialize
        {
            get { return Serialize.BrushToString(candleOutlineCondition1); }
            set { candleOutlineCondition1 = Serialize.StringToBrush(value); }
        }
				
		[XmlIgnore]				
		[Display(Name = "CandleOutlineCondition2", Description = "Color of CandleOutlineCondition2.", GroupName = "Visual", Order = 2)]
        public Brush CandleOutlineCondition2
        {
            get { return candleOutlineCondition2; }
            set { candleOutlineCondition2 = value; }
        }

        [Browsable(false)]
        public string CandleOutlineCondition2Serialize
        {
            get { return Serialize.BrushToString(candleOutlineCondition2); }
            set { candleOutlineCondition2 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]		
		[Display(Name = "CandleOutlineCondition3", Description = "Color of CandleOutlineCondition3.", GroupName = "Visual", Order = 3)]
        public Brush CandleOutlineCondition3
        {
            get { return candleOutlineCondition3; }
            set { candleOutlineCondition3 = value; }
        }

        [Browsable(false)]
        public string CandleOutlineCondition3Serialize
        {
            get { return Serialize.BrushToString(candleOutlineCondition3); }
            set { candleOutlineCondition3 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]	
		[Display(Name = "CandleOutlineCondition4", Description = "Color of CandleOutlineCondition4.", GroupName = "Visual", Order = 4)]
        public Brush CandleOutlineCondition4
        {
            get { return candleOutlineCondition4; }
            set { candleOutlineCondition4 = value; }
        }

        [Browsable(false)]
        public string CandleOutlineCondition4Serialize
        {
            get { return Serialize.BrushToString(candleOutlineCondition4); }
            set { candleOutlineCondition4 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]		
		[Display(Name = "CandleOutlineCondition5", Description = "Color of CandleOutlineCondition5.", GroupName = "Visual", Order = 5)]
        public Brush CandleOutlineCondition5
        {
            get { return candleOutlineCondition5; }
            set { candleOutlineCondition5 = value; }
        }

        [Browsable(false)]
        public string CandleOutlineCondition5Serialize
        {
            get { return Serialize.BrushToString(candleOutlineCondition5); }
            set { candleOutlineCondition5 = Serialize.StringToBrush(value); }
        }
		
		[XmlIgnore]
	
		[Display(Name = "CandleOutlineCondition6", Description = "Color of CandleOutlineCondition6.", GroupName = "Visual", Order = 6)]
        public Brush CandleOutlineCondition6
        {
            get { return candleOutlineCondition6; }
            set { candleOutlineCondition6 = value; }
        }

        [Browsable(false)]
        public string CandleOutlineCondition6Serialize
        {
            get { return Serialize.BrushToString(candleOutlineCondition6); }
            set { candleOutlineCondition6 = Serialize.StringToBrush(value); }
        }
	
		[Display(Name = "1. Color Zone?", Description = "Color Zone?", GroupName = "Colors", Order = 1)]		
		public bool Colorzone
		{
			get { return colorzone; }
			set { colorzone = value; }
		}
		
		[Display(Name = "2. Color Bars?", Description = "Color Bars?", GroupName = "Colors", Order = 2)]		
		public bool Colorbars
		{
			get { return colorbars; }
			set { colorbars = value; }
		}
	
		[Display(Name = "3. Color Bar Outline?", Description = "Color Bars Ouline?", GroupName = "Colors", Order = 3)]		
		public bool ColorOutline
		{
			get { return colorOutline; }
			set { colorOutline = value; }
		}		
		
		[Display(Name = "4. Color Zone Opacity", Description = "Zone Opacity 1-9", GroupName = "Colors", Order = 4)]		
		public int Zopacity
		{
			get { return zopacity; }
			set { zopacity = value; }
		}
		
		[XmlIgnore()]	
		[Display(Name = "5. Color for Rising MA?", Description = "Color for Rising MA", GroupName = "Colors", Order = 5)]
        public Brush MaUpColor
        {
            get { return maUpColor; }
            set { maUpColor = value; }
        }
		
		[Browsable(false)]
		public string MaUpColorSerialize
		{
			get { return Serialize.BrushToString(MaUpColor); }
			set { MaUpColor = Serialize.StringToBrush(value); }
		}
		
		[XmlIgnore()]
		[Display(Name = "6. Color for Falling MA?", Description = "Color for Falling MA", GroupName = "Colors", Order = 6)]
        public Brush MaDownColor
        {
            get { return maDownColor; }
            set { maDownColor = value; }
        }
		
		[Browsable(false)]
		public string MaDownColorSerialize
		{
			get { return Serialize.BrushToString(MaDownColor); }
			set { MaDownColor = Serialize.StringToBrush(value); }
		}
		
		[XmlIgnore()]
		
		[Display(Name = "7. Color for Zone?", Description = "Color for Zone", GroupName = "Colors", Order = 7)]
        public Brush ZoneColor
        {
            get { return zoneColor; }
            set { zoneColor = value; }
        }
		
		[Browsable(false)]
		public string ZoneColorSerialize
		{
			get { return Serialize.BrushToString(ZoneColor); }
			set { ZoneColor = Serialize.StringToBrush(value); }
		}
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private mah_Indicators.mahTrendGRaBer[] cachemahTrendGRaBer;
		public mah_Indicators.mahTrendGRaBer mahTrendGRaBer()
		{
			return mahTrendGRaBer(Input);
		}

		public mah_Indicators.mahTrendGRaBer mahTrendGRaBer(ISeries<double> input)
		{
			if (cachemahTrendGRaBer != null)
				for (int idx = 0; idx < cachemahTrendGRaBer.Length; idx++)
					if (cachemahTrendGRaBer[idx] != null &&  cachemahTrendGRaBer[idx].EqualsInput(input))
						return cachemahTrendGRaBer[idx];
			return CacheIndicator<mah_Indicators.mahTrendGRaBer>(new mah_Indicators.mahTrendGRaBer(), input, ref cachemahTrendGRaBer);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.mah_Indicators.mahTrendGRaBer mahTrendGRaBer()
		{
			return indicator.mahTrendGRaBer(Input);
		}

		public Indicators.mah_Indicators.mahTrendGRaBer mahTrendGRaBer(ISeries<double> input )
		{
			return indicator.mahTrendGRaBer(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.mah_Indicators.mahTrendGRaBer mahTrendGRaBer()
		{
			return indicator.mahTrendGRaBer(Input);
		}

		public Indicators.mah_Indicators.mahTrendGRaBer mahTrendGRaBer(ISeries<double> input )
		{
			return indicator.mahTrendGRaBer(input);
		}
	}
}

#endregion
